import java.util.HashMap;
import java.util.Map;
import java.lang.reflect.Constructor;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;

//XML̊Ot@CŒ`ꂽmodel̏
//f̃CX^X𐶐tH[hƈꏏ
//ێNX
public class ModelInfo {

    private String _modelName;
    private Model _model;
    private Map _forwardMap = new HashMap();


    //RXgN^
    public ModelInfo(Element event) throws Exception {
        
        //f擾
        NamedNodeMap nodeMap = event.getAttributes();
        String modelName =
                nodeMap.getNamedItem("name").getNodeValue();
        setModelName(modelName);
        
        //f̃NX擾
        String className = nodeMap
                .getNamedItem("class").getNodeValue();
        //f̃CX^X𐶐F
        Class cls = Class.forName(className);
        Constructor cons = cls.getConstructor(new Class[]{});
        setModel((Model)cons.newInstance(new Object[]{}));

        //tH[hJSPݒ
        NodeList forwards = event.getElementsByTagName("forward");
        for (int index = 0; index < forwards.getLength(); index++) {
            Element forward = (Element) forwards.item(index);
            NamedNodeMap forwardAttributeMap = forward.getAttributes();
            //tH[h擾
            String forwardName = forwardAttributeMap
                    .getNamedItem("name").getNodeValue();
            //tH[hJSP擾
            String jspName =  forwardAttributeMap
                    .getNamedItem("jsp").getNodeValue();
            
            //tH[hJSP̏MapIuWFNgɊi[
            addForward(forwardName, jspName);
        }
    }

    //tH[hɂAtH[hJSP擾
    public String getForward(String forwardName) {
        return (String) _forwardMap.get(forwardName);
    }

    //tH[hJSP̏MapIuWFNgɊi[
    public void addForward(String forwardName, String jspName) {
        if (forwardName == null) {
            throw new IllegalArgumentException();
        }
        if (jspName == null) {
            throw new IllegalArgumentException();
        }

        _forwardMap.put(forwardName, jspName);
    }

    public Model getModel() {
        return _model;
    }

    public void setModel(Model model) {
        if (model == null) {
            throw new IllegalArgumentException();
        }
        _model = model;
    }

    public String getModelName() {
        return _modelName;
    }

    public void setModelName(String modelName) {
        _modelName = modelName;
    }
}
