import java.util.List;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;
import net.sf.hibernate.Transaction;
import net.sf.hibernate.cfg.Configuration;
import net.sf.hibernate.Hibernate;

public class WorkerDAO {

    private SessionFactory sessionFactory = null;
    private static WorkerDAO instance = new WorkerDAO();

    /** RXgN^ **/
    private WorkerDAO() {
        try {
            Configuration config = new Configuration();
            config.configure();
            sessionFactory = config.buildSessionFactory();
        }catch(HibernateException ex) {
            ex.printStackTrace();
        }
    }

    /** DAOCX^X擾 **/
    public static WorkerDAO getInstance() {
        return instance;
    }

    /** ZbV擾 **/
    public Session getSession() throws HibernateException {
        return sessionFactory.openSession();
    }

    /** ZbVJ **/
    public void closeSession(Session session) {
        if (session != null) {
            try {
                session.close();
            } catch (HibernateException e) {}
        }
    }

    /** Worker̒ǉ **/
    public void create(Worker worker) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.save(worker);
            transaction.commit();
        } catch (HibernateException ex) {
            try {
                transaction.rollback();
            } catch (HibernateException ignore) {}
            throw new RuntimeException(ex.getMessage());
        } finally {
            closeSession(session);
        }
    }

    /** FOL[ɂČ **/
    public List findByName(String name) {
        Session session = null;
        List list = null;
        try {
            session = getSession();
            list =
                session.find("from Worker c where c.name = ?", name, Hibernate.STRING);
            if (list.isEmpty()) return null;
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            closeSession(session);
        }
        return list;
    }
}
