package insurance.action;

import insurance.form.EstimateForm;
import insurance.logic.Estimate;
import insurance.logic.EstimateValue;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;

/**
 * ςQActionNX
 */
public class EstimateAction extends Action {

    /** O */
    private Log log = LogFactory.getLog(this.getClass().getName());

    /**
     * ςQƃANV̎s
     *
     * @param mapping ANV}bsO
     * @param actionForm ANVtH[
     * @param request HTTPNGXg
     * @param response HTTPX|X
     * @return forward ANVtH[h
     *
     * @exception IOException o͗O
     * @exception ServletException T[ubgO
     */
    public ActionForward execute( ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws IOException, ServletException {

        ActionForward forward = null;
        ActionMessages messages = null;
        HttpSession session = null;

        LoginCheck loginCheck = null;
        String userType = "0";
        boolean bRet = false;

        EstimateForm estimateForm = null;
        EstimateValue inValue = null;
        EstimateValue outValue = null;
        Estimate estimate = null;

        try {

            //SeasarɂLoginCheckCX^X̎擾
            S2Container container = S2ContainerFactory.create("logic.dicon");
            loginCheck = (LoginCheck)container.getComponent("loginCheck");
            // OCς݃`FbN
            bRet = loginCheck.check(request, userType);

            if (!bRet) {
                return mapping.findForward("loginerror");
            }

            estimateForm = (EstimateForm)form;
            session = request.getSession();

            inValue = estimateForm.getEstimateValue();
            inValue.setUserId((String)session.getAttribute("userId"));

            //SeasarɂEstimateCX^X̎擾
            estimate = (Estimate)container.getComponent("estimate");
            outValue = estimate.execute(inValue);

            if (null == outValue) {

                messages = new ActionMessages();
                messages.add(ActionMessages.GLOBAL_MESSAGE,
                           new ActionMessage("error.not.insurance.price"));
                saveErrors(request, messages);
                return new ActionForward(mapping.getInput());

            }

            request.setAttribute("estimateValue",outValue);

            forward = new ActionForward(mapping.getInput());

        } catch ( Exception ex ) {
            log.fatal(ex.getMessage());
            forward = mapping.findForward("fatalerror");
        }

        return forward;

    }

}
