package insurance.db;

import java.util.List;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;
import net.sf.hibernate.cfg.Configuration;

/**
 * DAOx[XNX
 */
public abstract class BaseDAO {

    /** singletonŎ */
    private static SessionFactory sessionFactory = null;

    /** ZbVt@Ng̎擾 **/
    private synchronized static  SessionFactory getSessionFactory() 
    throws HibernateException {
        if (null == sessionFactory) {
            Configuration config = new Configuration();
            config.configure();
            sessionFactory = config.buildSessionFactory();
        }
        return sessionFactory;
    }

    /** ZbV̎擾 */
    protected Session getSession() throws HibernateException {
        return getSessionFactory().openSession();
    }

    /** ZbV̉ **/
    protected void closeSession(Session session) {
        if (session != null) {
            try {
                session.close();
            } catch (HibernateException e) {}
        }
    }

    /**
     * vC}L[ɂӃf[^̎擾
     *
     * @param primaryKey vC}L[
     * @return Ӄf[^̃Xg
     *
     * @exception Exception O
     */
    protected List findByPrimaryKey( String primaryKey ) 
    throws Exception {

        Session session = null;
        List list = null;

        try {

            session = getSession();

            list = find(session,primaryKey);

            if (list.isEmpty()) return null;

        } catch (HibernateException ex) {

            ex.printStackTrace();
            throw new Exception(ex.getMessage());

        } finally {
            closeSession(session);
        }

        return list;
    }

    /**
     * eTuNXɂvC}L[̈Ӄf[^̎擾
     *
     * @param session ZbV
     * @param primaryKey vC}L[
     * @return Ӄf[^̃Xg
     *
     * @exception HibernateException O
     */
    protected abstract List find(Session session, String primaryKey)
    throws HibernateException;

}
