package insurance.logic;

import java.util.List;
import insurance.db.UserDAO;
import insurance.db.UserData;
import insurance.db.ContractItemDAO;
import insurance.db.ContractItemData;
import insurance.db.InsuranceClassDAO;
import insurance.db.InsuranceClassData;
import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;


/**
 * ςQƃWbNNX
 */
public class EstimateLogic implements Estimate {
    
    /**
     * ςQƎs
     * 
     * @param inValue _A
     * @return ̌_ɂʕیz
     *
     * @exception Exception O
     */
    public EstimateValue execute (EstimateValue inValue)
		    throws Exception {
        
        EstimateValue outValue = null;
		UserDAO userDAO = null;
		UserData userData = null;
        ContractItemDAO contractItemDAO = null;
        ContractItemData contractItemData = null;
        InsuranceClassDAO insuranceClassDAO = null;
        InsuranceClassData insuranceClassData = null;

        String price = null;

		List userList = null;
        List contractItemList = null;
        List insuranceClassList = null;

		userDAO = UserDAO.create();
		userList = userDAO.findByPrimarykey(inValue.getUserId());

		if (userList == null) {
			return null;
		}

		userData = (UserData)userList.get(0);
        
        contractItemDAO = ContractItemDAO.create();
        contractItemList =
                contractItemDAO.findByPrimarykey(inValue.getContractItem());
        
        insuranceClassDAO = InsuranceClassDAO.create();
        insuranceClassList =
                insuranceClassDAO.findByPrimarykey(userData.getInsuranceClass());

        if (contractItemList == null || insuranceClassList == null) {
            return null;
        }

        contractItemData= (ContractItemData)contractItemList.get(0);
        insuranceClassData= (InsuranceClassData)insuranceClassList.get(0);

		//SeasarɂPremiumCheckCX^X̎擾
		S2Container container = S2ContainerFactory.create("logic.dicon");
		PremiumCheck check = (PremiumCheck)container.getComponent("premiumCheck");

        price = check.calculate(
                insuranceClassData.getPrice(),contractItemData.getRate());

        outValue = new EstimateValue();
        outValue.setPrice(price);
        
        return outValue;
        
    }
}
